{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}


module Curry_Directory (d_C_doesFileExist, d_C_doesDirectoryExist, d_C_fileSize, d_C_getModificationTime, d_C_setCurrentDirectory, d_C_getDirectoryContents, d_C_createDirectory, d_C_createDirectoryIfMissing, d_C_removeDirectory, d_C_renameDirectory, d_C_getHomeDirectory, d_C_getTemporaryDirectory, d_C_removeFile, d_C_renameFile, d_C_copyFile, d_C_getCurrentDirectory) where

import Basics
import qualified Curry_FilePath
import qualified Curry_List
import qualified Curry_Prelude
import qualified Curry_System
import qualified Curry_Time

import System.Directory
import System.IO
import System.Time



d_C_doesFileExist :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_doesFileExist x1 cd cs = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_doesFileExist x1 cd cs

d_C_doesDirectoryExist :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_doesDirectoryExist x1 cd cs = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_doesDirectoryExist x1 cd cs

d_C_fileSize :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Int
d_C_fileSize x1 cd cs = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_fileSize x1 cd cs

d_C_getModificationTime :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Time.C_ClockTime
d_C_getModificationTime x1 cd cs = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_getModificationTime x1 cd cs

d_C_setCurrentDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_setCurrentDirectory x1 cd cs = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_setCurrentDirectory x1 cd cs

d_C_getDirectoryContents :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_getDirectoryContents x1 cd cs = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_getDirectoryContents x1 cd cs

d_C_createDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_createDirectory x1 cd cs = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_createDirectory x1 cd cs

d_C_createDirectoryIfMissing :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_createDirectoryIfMissing x1 x2 cd cs = let
     x3 = Curry_Prelude.d_OP_dollar (Curry_List.d_C_scanl1 (Curry_FilePath.d_OP_lt_slash_gt cd cs)) (Curry_Prelude.d_OP_dollar Curry_FilePath.d_C_splitDirectories x2 cd cs) cd cs
      in (d_C__case_3 x3 x1 cd cs)

d_OP_createDirectoryIfMissing_dot_createDirs_dot_16 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_createDirectoryIfMissing_dot_createDirs_dot_16 x1 cd cs = case x1 of
     Curry_Prelude.OP_List -> Curry_Prelude.d_C_done cd cs
     (Curry_Prelude.OP_Cons x2 x3) -> Curry_Prelude.d_OP_gt_gt_eq (d_C_doesDirectoryExist x2 cd cs) (d_OP_createDirectoryIfMissing_dot_createDirs_dot_16_dot_uscore_hash_lambda1 x2 x3) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_OP_createDirectoryIfMissing_dot_createDirs_dot_16 l cd cs) (d_OP_createDirectoryIfMissing_dot_createDirs_dot_16 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_OP_createDirectoryIfMissing_dot_createDirs_dot_16 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_OP_createDirectoryIfMissing_dot_createDirs_dot_16 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "Directory.createDirectoryIfMissing.createDirs.16" [(show x1)] info)
     _ -> failCons cd (consFail "Directory.createDirectoryIfMissing.createDirs.16" (showCons x1))

d_OP_createDirectoryIfMissing_dot_createDirs_dot_16_dot_uscore_hash_lambda1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_createDirectoryIfMissing_dot_createDirs_dot_16_dot_uscore_hash_lambda1 x1 x2 x3 cd cs = Curry_Prelude.d_OP_gt_gt (d_C__case_2 x1 x3 cd cs) (d_OP_createDirectoryIfMissing_dot_createDirs_dot_16 x2 cd cs) cd cs

d_C_removeDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_removeDirectory x1 cd cs = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_removeDirectory x1 cd cs

d_C_renameDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_renameDirectory x1 x2 cd cs = Curry_Prelude.d_OP_dollar_hash_hash (Curry_Prelude.d_OP_dollar_hash_hash (acceptCs id d_C_prim_renameDirectory) x1 cd cs) x2 cd cs

d_C_getHomeDirectory :: Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getHomeDirectory cd cs = d_C__case_1 (Curry_System.d_C_isWindows cd cs) cd cs

d_C_getTemporaryDirectory :: Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getTemporaryDirectory cd cs = d_C__case_0 (Curry_System.d_C_isWindows cd cs) cd cs

d_C_removeFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_removeFile x1 cd cs = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_removeFile x1 cd cs

d_C_renameFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_renameFile x1 x2 cd cs = Curry_Prelude.d_OP_dollar_hash_hash (Curry_Prelude.d_OP_dollar_hash_hash (acceptCs id d_C_prim_renameFile) x1 cd cs) x2 cd cs

d_C_copyFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_copyFile x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (Curry_Prelude.d_C_readFile x1 cd cs) (Curry_Prelude.d_C_writeFile x2) cd cs

d_C__case_0 :: Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_0 x1 cd cs = case x1 of
     Curry_Prelude.C_True -> Curry_System.d_C_getEnviron (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'M'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'P'#) Curry_Prelude.OP_List))) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_return (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '/'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) Curry_Prelude.OP_List)))) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_0 l cd cs) (d_C__case_0 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_0 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_0 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "Directory._case_0" [(show x1)] info)
     _ -> failCons cd (consFail "Directory._case_0" (showCons x1))

d_C__case_1 :: Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_1 x1 cd cs = case x1 of
     Curry_Prelude.C_True -> Curry_System.d_C_getEnviron (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'U'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'S'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'E'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'R'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'P'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'R'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'O'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'F'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'I'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'L'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'E'#) Curry_Prelude.OP_List))))))))))) cd cs
     Curry_Prelude.C_False -> Curry_System.d_C_getEnviron (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'H'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'O'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'M'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'E'#) Curry_Prelude.OP_List)))) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_1 l cd cs) (d_C__case_1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "Directory._case_1" [(show x1)] info)
     _ -> failCons cd (consFail "Directory._case_1" (showCons x1))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_done cd cs
     Curry_Prelude.C_False -> d_C_createDirectory x1 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_2 x1 l cd cs) (d_C__case_2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "Directory._case_2" [(show x1),(show x3)] info)
     _ -> failCons cd (consFail "Directory._case_2" (showCons x3))

d_C__case_3 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_3 x3 x1 cd cs = case x1 of
     Curry_Prelude.C_True -> d_OP_createDirectoryIfMissing_dot_createDirs_dot_16 x3 cd cs
     Curry_Prelude.C_False -> d_OP_createDirectoryIfMissing_dot_createDirs_dot_16 (Curry_Prelude.OP_Cons (Curry_List.d_C_last x3 cd cs) Curry_Prelude.OP_List) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_3 x3 l cd cs) (d_C__case_3 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_3 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_3 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "Directory._case_3" [(show x3),(show x1)] info)
     _ -> failCons cd (consFail "Directory._case_3" (showCons x1))

d_C_prim_doesFileExist :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_prim_doesFileExist x1 cd cs = external_d_C_prim_doesFileExist x1 cd cs

d_C_prim_doesDirectoryExist :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_prim_doesDirectoryExist x1 cd cs = external_d_C_prim_doesDirectoryExist x1 cd cs

d_C_prim_fileSize :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Int
d_C_prim_fileSize x1 cd cs = external_d_C_prim_fileSize x1 cd cs

d_C_prim_getModificationTime :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Time.C_ClockTime
d_C_prim_getModificationTime x1 cd cs = external_d_C_prim_getModificationTime x1 cd cs

d_C_getCurrentDirectory :: Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getCurrentDirectory cd cs = external_d_C_getCurrentDirectory cd cs

d_C_prim_setCurrentDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_setCurrentDirectory x1 cd cs = external_d_C_prim_setCurrentDirectory x1 cd cs

d_C_prim_getDirectoryContents :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_prim_getDirectoryContents x1 cd cs = external_d_C_prim_getDirectoryContents x1 cd cs

d_C_prim_createDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_createDirectory x1 cd cs = external_d_C_prim_createDirectory x1 cd cs

d_C_prim_removeDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_removeDirectory x1 cd cs = external_d_C_prim_removeDirectory x1 cd cs

d_C_prim_renameDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_renameDirectory x1 x2 cd cs = external_d_C_prim_renameDirectory x1 x2 cd cs

d_C_prim_removeFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_removeFile x1 cd cs = external_d_C_prim_removeFile x1 cd cs

d_C_prim_renameFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_renameFile x1 x2 cd cs = external_d_C_prim_renameFile x1 x2 cd cs

external_d_C_prim_doesFileExist :: Curry_Prelude.C_String -> Cover -> ConstStore
                                -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
external_d_C_prim_doesFileExist s _ _ = toCurry doesFileExist s

external_d_C_prim_doesDirectoryExist :: Curry_Prelude.C_String -> Cover -> ConstStore
                                     -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
external_d_C_prim_doesDirectoryExist s _ _ = toCurry doesDirectoryExist s

external_d_C_prim_fileSize :: Curry_Prelude.C_String -> Cover -> ConstStore
                           -> Curry_Prelude.C_IO Curry_Prelude.C_Int
external_d_C_prim_fileSize s _ _ = toCurry
  (\f -> do h <- openFile f ReadMode
            i <- hFileSize h
            hClose h
            return i
  ) s

external_d_C_prim_getModificationTime :: Curry_Prelude.C_String -> Cover -> ConstStore
                                      -> Curry_Prelude.C_IO Curry_Time.C_ClockTime
external_d_C_prim_getModificationTime s _ _ = toCurry getModificationTime s

external_d_C_getCurrentDirectory :: Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_String)
external_d_C_getCurrentDirectory _ _ = toCurry getCurrentDirectory

external_d_C_prim_setCurrentDirectory :: Curry_Prelude.C_String -> Cover -> ConstStore
                                      -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_prim_setCurrentDirectory s _ _ = toCurry setCurrentDirectory s

external_d_C_prim_getDirectoryContents :: Curry_Prelude.C_String -> Cover -> ConstStore
                                       -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.C_String))
external_d_C_prim_getDirectoryContents s _ _ = toCurry getDirectoryContents s

external_d_C_prim_createDirectory :: Curry_Prelude.C_String -> Cover -> ConstStore
                                  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_prim_createDirectory s _ _ = toCurry createDirectory s

external_d_C_prim_removeFile :: Curry_Prelude.C_String -> Cover -> ConstStore
                             -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_prim_removeFile s _ _ = toCurry removeFile s

external_d_C_prim_removeDirectory :: Curry_Prelude.C_String -> Cover -> ConstStore
                                  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_prim_removeDirectory s _ _ = toCurry removeDirectory s

external_d_C_prim_renameFile :: Curry_Prelude.C_String -> Curry_Prelude.C_String -> Cover -> ConstStore
                             -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_prim_renameFile s1 s2 _ _ = toCurry renameFile s1 s2

external_d_C_prim_renameDirectory :: Curry_Prelude.C_String -> Curry_Prelude.C_String
                                  -> Cover -> ConstStore 
                                  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
external_d_C_prim_renameDirectory s1 s2 _ _= toCurry renameDirectory s1 s2
