{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}


module Curry_AbstractHaskellGoodies (d_C_lowerFirst, d_C_applyF, d_C_constF, d_C_applyV, d_C_tuplePat, d_C_tupleExpr, d_C_tuplePattern, d_OP_tilde_gt, d_C_baseType, d_C_listType, d_C_tupleType, d_C_ioType, d_C_maybeType, d_C_stringType, d_C_intType, d_C_boolType, d_C_dateType, d_C_tyVarsOf, d_C_tfunc, d_C_ctfunc, d_C_ufunc, d_C_cmtfunc, d_C_string2ac, d_C_simpleRule, d_C_noGuard, d_C_pre, d_C_cvar, d_C_clet, d_C_ctvar, d_C_list2ac, d_C_declVar, d_C_renameSymbolInProg, nd_C_renameSymbolInProg, d_C_renameSymbolInTypeDecl, nd_C_renameSymbolInTypeDecl, d_C_renameSymbolInConsDecl, nd_C_renameSymbolInConsDecl, d_C_renameSymbolInTypeExpr, nd_C_renameSymbolInTypeExpr, d_C_renameSymbolInExpr, nd_C_renameSymbolInExpr, d_C_renameSymbolInPat, nd_C_renameSymbolInPat, d_C_renameSymbolInBranch, nd_C_renameSymbolInBranch, d_C_renameSymbolInStat, nd_C_renameSymbolInStat, d_C_renameSymbolInLocal, nd_C_renameSymbolInLocal, d_C_renameSymbolInTypeSig, nd_C_renameSymbolInTypeSig, d_C_renameSymbolInFunc, nd_C_renameSymbolInFunc, d_C_renameSymbolInRules, nd_C_renameSymbolInRules, d_C_renameSymbolInRule, nd_C_renameSymbolInRule, d_C_renameOpDecl, nd_C_renameOpDecl, d_C_funcDecls, d_C_funcName, d_C_typeOf, d_C_commentOf) where

import Basics
import qualified Curry_AbstractHaskell
import qualified Curry_Char
import qualified Curry_List
import qualified Curry_Prelude

d_C_lowerFirst :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_lowerFirst x1 cd cs = case x1 of
     (Curry_Prelude.OP_Cons x2 x3) -> Curry_Prelude.OP_Cons (Curry_Char.d_C_toLower x2 cd cs) x3
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C_lowerFirst l cd cs) (d_C_lowerFirst r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C_lowerFirst z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C_lowerFirst e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "AbstractHaskellGoodies.lowerFirst" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.lowerFirst" (showCons x1))

d_C_applyF :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Expr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C_applyF x1 x2 cd cs = Curry_Prelude.d_C_foldl (acceptCs (acceptCs id) Curry_AbstractHaskell.C_Apply) (Curry_AbstractHaskell.C_Symbol x1) x2 cd cs

d_C_constF :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C_constF x1 cd cs = d_C_applyF x1 Curry_Prelude.OP_List cd cs

d_C_applyV :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Expr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C_applyV x1 x2 cd cs = Curry_Prelude.d_C_foldl (acceptCs (acceptCs id) Curry_AbstractHaskell.C_Apply) (Curry_AbstractHaskell.C_Var x1) x2 cd cs

d_C_tuplePat :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_Pattern -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Pattern
d_C_tuplePat x1 cd cs = let
     x2 = Curry_Prelude.d_C_length x1 cd cs
      in (d_C__case_12 x2 x1 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 0#) cd cs) cd cs)

d_C_tupleExpr :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_Expr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C_tupleExpr x1 cd cs = let
     x2 = Curry_Prelude.d_C_length x1 cd cs
      in (d_C__case_9 x2 x1 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 0#) cd cs) cd cs)

d_C_tuplePattern :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_Pattern -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Pattern
d_C_tuplePattern x1 cd cs = let
     x2 = Curry_Prelude.d_C_length x1 cd cs
      in (d_C__case_6 x2 x1 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 0#) cd cs) cd cs)

d_OP_tilde_gt :: Curry_AbstractHaskell.C_TypeExpr -> Curry_AbstractHaskell.C_TypeExpr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_OP_tilde_gt x1 x2 cd cs = Curry_AbstractHaskell.C_FuncType x1 x2

d_C_baseType :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_baseType x1 cd cs = Curry_AbstractHaskell.C_TCons x1 Curry_Prelude.OP_List

d_C_listType :: Curry_AbstractHaskell.C_TypeExpr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_listType x1 cd cs = Curry_AbstractHaskell.C_TCons (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '['#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ']'#) Curry_Prelude.OP_List)) cd cs) (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List)

d_C_tupleType :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_TypeExpr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_tupleType x1 cd cs = let
     x2 = Curry_Prelude.d_C_length x1 cd cs
      in (d_C__case_3 x2 x1 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 0#) cd cs) cd cs)

d_C_ioType :: Curry_AbstractHaskell.C_TypeExpr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_ioType x1 cd cs = Curry_AbstractHaskell.C_TCons (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'I'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'O'#) Curry_Prelude.OP_List)) cd cs) (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List)

d_C_maybeType :: Curry_AbstractHaskell.C_TypeExpr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_maybeType x1 cd cs = Curry_AbstractHaskell.C_TCons (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'M'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'y'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List))))) cd cs) (Curry_Prelude.OP_Cons x1 Curry_Prelude.OP_List)

d_C_stringType :: Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_stringType cd cs = d_C_baseType (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'S'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'g'#) Curry_Prelude.OP_List)))))) cd cs) cd cs

d_C_intType :: Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_intType cd cs = d_C_baseType (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'I'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) Curry_Prelude.OP_List))) cd cs) cd cs

d_C_boolType :: Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_boolType cd cs = d_C_baseType (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'B'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) Curry_Prelude.OP_List)))) cd cs) cd cs

d_C_dateType :: Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_dateType cd cs = d_C_baseType (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List)))) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List))))))))))))) cd cs

d_C_tyVarsOf :: Curry_AbstractHaskell.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_tyVarsOf x1 cd cs = case x1 of
     (Curry_AbstractHaskell.C_TVar x2) -> Curry_Prelude.OP_Cons x2 Curry_Prelude.OP_List
     (Curry_AbstractHaskell.C_FuncType x3 x4) -> Curry_List.d_C_union (d_C_tyVarsOf x3 cd cs) (d_C_tyVarsOf x4 cd cs) cd cs
     (Curry_AbstractHaskell.C_TCons x5 x6) -> Curry_Prelude.d_C_foldr (acceptCs id Curry_List.d_C_union) Curry_Prelude.OP_List (Curry_Prelude.d_C_map d_C_tyVarsOf x6 cd cs) cd cs
     (Curry_AbstractHaskell.Choice_C_TypeExpr d i l r) -> narrow d i (d_C_tyVarsOf l cd cs) (d_C_tyVarsOf r cd cs)
     (Curry_AbstractHaskell.Choices_C_TypeExpr d i xs) -> narrows cs d i (\z -> d_C_tyVarsOf z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_TypeExpr d c e) -> guardCons d c ((d_C_tyVarsOf e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_TypeExpr d info) -> failCons d (traceFail "AbstractHaskellGoodies.tyVarsOf" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.tyVarsOf" (showCons x1))

d_C_tfunc :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_AbstractHaskell.C_Visibility -> Curry_AbstractHaskell.C_TypeExpr -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Rule -> Cover -> ConstStore -> Curry_AbstractHaskell.C_FuncDecl
d_C_tfunc x1 x2 x3 x4 x5 cd cs = Curry_AbstractHaskell.C_Func Curry_Prelude.OP_List x1 x2 x3 (Curry_AbstractHaskell.C_FType x4) (Curry_AbstractHaskell.C_Rules x5)

d_C_ctfunc :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_AbstractHaskell.C_Visibility -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Context -> Curry_AbstractHaskell.C_TypeExpr -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Rule -> Cover -> ConstStore -> Curry_AbstractHaskell.C_FuncDecl
d_C_ctfunc x1 x2 x3 x4 x5 x6 cd cs = Curry_AbstractHaskell.C_Func Curry_Prelude.OP_List x1 x2 x3 (Curry_AbstractHaskell.C_CType x4 x5) (Curry_AbstractHaskell.C_Rules x6)

d_C_ufunc :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_AbstractHaskell.C_Visibility -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Rule -> Cover -> ConstStore -> Curry_AbstractHaskell.C_FuncDecl
d_C_ufunc x1 x2 x3 x4 cd cs = Curry_AbstractHaskell.C_Func Curry_Prelude.OP_List x1 x2 x3 Curry_AbstractHaskell.C_Untyped (Curry_AbstractHaskell.C_Rules x4)

d_C_cmtfunc :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_AbstractHaskell.C_Visibility -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Context -> Curry_AbstractHaskell.C_TypeExpr -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Rule -> Cover -> ConstStore -> Curry_AbstractHaskell.C_FuncDecl
d_C_cmtfunc x1 x2 x3 x4 x5 x6 x7 cd cs = Curry_AbstractHaskell.C_Func x1 x2 x3 x4 (Curry_AbstractHaskell.C_CType x5 x6) (Curry_AbstractHaskell.C_Rules x7)

d_C_string2ac :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C_string2ac cd cs = Curry_Prelude.d_OP_dot (acceptCs id Curry_AbstractHaskell.C_Lit) (acceptCs id Curry_AbstractHaskell.C_Stringc) cd cs

d_C_simpleRule :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_Pattern -> Curry_AbstractHaskell.C_Expr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Rules
d_C_simpleRule x1 x2 cd cs = Curry_AbstractHaskell.C_Rules (Curry_Prelude.OP_Cons (Curry_AbstractHaskell.C_Rule x1 (Curry_Prelude.OP_Cons (d_C_noGuard x2 cd cs) Curry_Prelude.OP_List) Curry_Prelude.OP_List) Curry_Prelude.OP_List)

d_C_noGuard :: Curry_AbstractHaskell.C_Expr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Expr Curry_AbstractHaskell.C_Expr
d_C_noGuard x1 cd cs = Curry_Prelude.OP_Tuple2 (Curry_AbstractHaskell.C_Symbol (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) Curry_Prelude.OP_List))))))) cd cs)) x1

d_C_pre :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_pre x1 cd cs = Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'P'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List))))))) x1

d_C_cvar :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C_cvar x1 cd cs = Curry_AbstractHaskell.C_Var (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int 1#) x1)

d_C_clet :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_LocalDecl -> Curry_AbstractHaskell.C_Expr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C_clet x1 x2 cd cs = d_C__case_0 x1 x2 (Curry_Prelude.d_C_null x1 cd cs) cd cs

d_C_ctvar :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_ctvar x1 cd cs = Curry_AbstractHaskell.C_TVar (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int 1#) x1)

d_C_list2ac :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_Expr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C_list2ac x1 cd cs = case x1 of
     Curry_Prelude.OP_List -> d_C_applyF (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '['#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ']'#) Curry_Prelude.OP_List)) cd cs) Curry_Prelude.OP_List cd cs
     (Curry_Prelude.OP_Cons x2 x3) -> d_C_applyF (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) Curry_Prelude.OP_List) cd cs) (Curry_Prelude.OP_Cons x2 (Curry_Prelude.OP_Cons (d_C_list2ac x3 cd cs) Curry_Prelude.OP_List)) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C_list2ac l cd cs) (d_C_list2ac r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C_list2ac z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C_list2ac e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "AbstractHaskellGoodies.list2ac" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.list2ac" (showCons x1))

d_C_declVar :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_AbstractHaskell.C_Expr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_LocalDecl
d_C_declVar x1 x2 cd cs = Curry_AbstractHaskell.C_LocalPat (Curry_AbstractHaskell.C_PVar x1) x2 Curry_Prelude.OP_List

d_C_renameSymbolInProg :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Prog
d_C_renameSymbolInProg x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Prog x3 x4 x5 x6 x7) -> Curry_AbstractHaskell.C_Prog (Curry_Prelude.d_C_fst (Curry_Prelude.d_C_apply x1 (Curry_Prelude.OP_Tuple2 x3 Curry_Prelude.OP_List) cd cs) cd cs) (Curry_Prelude.d_C_map (d_OP_renameSymbolInProg_dot_uscore_hash_lambda1 x1) x4 cd cs) (Curry_Prelude.d_C_map (d_C_renameSymbolInTypeDecl x1) x5 cd cs) (Curry_Prelude.d_C_map (d_C_renameSymbolInFunc x1) x6 cd cs) (Curry_Prelude.d_C_map (d_C_renameOpDecl x1) x7 cd cs)
     (Curry_AbstractHaskell.Choice_C_Prog d i l r) -> narrow d i (d_C_renameSymbolInProg x1 l cd cs) (d_C_renameSymbolInProg x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_Prog d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInProg x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Prog d c e) -> guardCons d c ((d_C_renameSymbolInProg x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Prog d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInProg" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInProg" (showCons x2))

nd_C_renameSymbolInProg :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Prog -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Prog
nd_C_renameSymbolInProg x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Prog x3 x4 x5 x6 x7) -> let
          s5 = s
           in (seq s5 (let
               s6 = leftSupply s5
               s7 = rightSupply s5
               s0 = leftSupply s6
               s1 = rightSupply s6
               s2 = leftSupply s7
               s8 = rightSupply s7
               s3 = leftSupply s8
               s4 = rightSupply s8
                in (seq s6 (seq s7 (seq s0 (seq s1 (seq s2 (seq s8 (seq s3 (seq s4 (Curry_AbstractHaskell.C_Prog (let
                     in (Curry_Prelude.d_C_fst (let
                          in (Curry_Prelude.nd_C_apply x1 (Curry_Prelude.OP_Tuple2 x3 Curry_Prelude.OP_List) s0 cd cs)) cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_OP_renameSymbolInProg_dot_uscore_hash_lambda1 x1)) x4 s1 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInTypeDecl x1)) x5 s2 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInFunc x1)) x6 s3 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameOpDecl x1)) x7 s4 cd cs)))))))))))))
     (Curry_AbstractHaskell.Choice_C_Prog d i l r) -> narrow d i (nd_C_renameSymbolInProg x1 l s cd cs) (nd_C_renameSymbolInProg x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_Prog d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInProg x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Prog d c e) -> guardCons d c ((nd_C_renameSymbolInProg x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Prog d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInProg" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInProg" (showCons x2))

d_OP_renameSymbolInProg_dot_uscore_hash_lambda1 :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_renameSymbolInProg_dot_uscore_hash_lambda1 x1 x2 cd cs = Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_fst (Curry_Prelude.d_C_apply x1 (Curry_Prelude.OP_Tuple2 x2 Curry_Prelude.OP_List) cd cs) cd cs

nd_OP_renameSymbolInProg_dot_uscore_hash_lambda1 :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
nd_OP_renameSymbolInProg_dot_uscore_hash_lambda1 x1 x2 s cd cs = let
     s2 = s
      in (seq s2 (let
          s1 = leftSupply s2
          s0 = rightSupply s2
           in (seq s1 (seq s0 (Curry_Prelude.nd_OP_dollar (wrapDX id Curry_Prelude.d_C_fst) (let
                in (Curry_Prelude.nd_C_apply x1 (Curry_Prelude.OP_Tuple2 x2 Curry_Prelude.OP_List) s0 cd cs)) s1 cd cs)))))

d_C_renameSymbolInTypeDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_TypeDecl -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeDecl
d_C_renameSymbolInTypeDecl x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Type x3 x4 x5 x6) -> Curry_AbstractHaskell.C_Type (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 x5 (Curry_Prelude.d_C_map (d_C_renameSymbolInConsDecl x1) x6 cd cs)
     (Curry_AbstractHaskell.C_TypeSyn x7 x8 x9 x10) -> Curry_AbstractHaskell.C_TypeSyn (Curry_Prelude.d_C_apply x1 x7 cd cs) x8 x9 (d_C_renameSymbolInTypeExpr x1 x10 cd cs)
     (Curry_AbstractHaskell.C_Instance x11 x12 x13 x14) -> Curry_AbstractHaskell.C_Instance (Curry_Prelude.d_C_apply x1 x11 cd cs) (d_C_renameSymbolInTypeExpr x1 x12 cd cs) (Curry_Prelude.d_C_map (d_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1) x13 cd cs) (Curry_Prelude.d_C_map (d_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1) x14 cd cs)
     (Curry_AbstractHaskell.Choice_C_TypeDecl d i l r) -> narrow d i (d_C_renameSymbolInTypeDecl x1 l cd cs) (d_C_renameSymbolInTypeDecl x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_TypeDecl d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInTypeDecl x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_TypeDecl d c e) -> guardCons d c ((d_C_renameSymbolInTypeDecl x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_TypeDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeDecl" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeDecl" (showCons x2))

nd_C_renameSymbolInTypeDecl :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_TypeDecl -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeDecl
nd_C_renameSymbolInTypeDecl x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Type x3 x4 x5 x6) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_Type (let
                     in (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)) x4 x5 (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInConsDecl x1)) x6 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_TypeSyn x7 x8 x9 x10) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_TypeSyn (let
                     in (Curry_Prelude.nd_C_apply x1 x7 s0 cd cs)) x8 x9 (let
                     in (nd_C_renameSymbolInTypeExpr x1 x10 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_Instance x11 x12 x13 x14) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s0 = leftSupply s5
               s1 = rightSupply s5
               s2 = leftSupply s6
               s3 = rightSupply s6
                in (seq s5 (seq s6 (seq s0 (seq s1 (seq s2 (seq s3 (Curry_AbstractHaskell.C_Instance (let
                     in (Curry_Prelude.nd_C_apply x1 x11 s0 cd cs)) (let
                     in (nd_C_renameSymbolInTypeExpr x1 x12 s1 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1)) x13 s2 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1)) x14 s3 cd cs)))))))))))
     (Curry_AbstractHaskell.Choice_C_TypeDecl d i l r) -> narrow d i (nd_C_renameSymbolInTypeDecl x1 l s cd cs) (nd_C_renameSymbolInTypeDecl x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_TypeDecl d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInTypeDecl x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_TypeDecl d c e) -> guardCons d c ((nd_C_renameSymbolInTypeDecl x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_TypeDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeDecl" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeDecl" (showCons x2))

d_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_AbstractHaskell.C_Rule -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_AbstractHaskell.C_Rule
d_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_apply x1 x3 cd cs) (d_C_renameSymbolInRule x1 x4 cd cs)
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1 l cd cs) (d_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeDecl.renameSymbolInInstRule.94" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeDecl.renameSymbolInInstRule.94" (showCons x2))

nd_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_AbstractHaskell.C_Rule -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_AbstractHaskell.C_Rule
nd_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1 x2 s cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_Prelude.OP_Tuple2 (let
                     in (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)) (let
                     in (nd_C_renameSymbolInRule x1 x4 s1 cd cs)))))))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1 l s cd cs) (nd_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_OP_renameSymbolInTypeDecl_dot_renameSymbolInInstRule_dot_94 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeDecl.renameSymbolInInstRule.94" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeDecl.renameSymbolInInstRule.94" (showCons x2))

d_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Context -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Context
d_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Context x3 x4) -> Curry_AbstractHaskell.C_Context (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
     (Curry_AbstractHaskell.Choice_C_Context d i l r) -> narrow d i (d_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1 l cd cs) (d_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_Context d i xs) -> narrows cs d i (\z -> d_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Context d c e) -> guardCons d c ((d_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Context d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeDecl._#lambda3" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeDecl._#lambda3" (showCons x2))

nd_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Context -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Context
nd_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Context x3 x4) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_Context (let
                     in (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)) x4)))
     (Curry_AbstractHaskell.Choice_C_Context d i l r) -> narrow d i (nd_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1 l s cd cs) (nd_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_Context d i xs) -> narrows cs d i (\z -> nd_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Context d c e) -> guardCons d c ((nd_OP_renameSymbolInTypeDecl_dot_uscore_hash_lambda3 x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Context d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeDecl._#lambda3" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeDecl._#lambda3" (showCons x2))

d_C_renameSymbolInConsDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_ConsDecl -> Cover -> ConstStore -> Curry_AbstractHaskell.C_ConsDecl
d_C_renameSymbolInConsDecl x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Cons x3 x4 x5 x6) -> Curry_AbstractHaskell.C_Cons (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 x5 (Curry_Prelude.d_C_map (d_C_renameSymbolInTypeExpr x1) x6 cd cs)
     (Curry_AbstractHaskell.Choice_C_ConsDecl d i l r) -> narrow d i (d_C_renameSymbolInConsDecl x1 l cd cs) (d_C_renameSymbolInConsDecl x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_ConsDecl d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInConsDecl x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_ConsDecl d c e) -> guardCons d c ((d_C_renameSymbolInConsDecl x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_ConsDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInConsDecl" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInConsDecl" (showCons x2))

nd_C_renameSymbolInConsDecl :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_ConsDecl -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_ConsDecl
nd_C_renameSymbolInConsDecl x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Cons x3 x4 x5 x6) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_Cons (let
                     in (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)) x4 x5 (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInTypeExpr x1)) x6 s1 cd cs)))))))
     (Curry_AbstractHaskell.Choice_C_ConsDecl d i l r) -> narrow d i (nd_C_renameSymbolInConsDecl x1 l s cd cs) (nd_C_renameSymbolInConsDecl x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_ConsDecl d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInConsDecl x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_ConsDecl d c e) -> guardCons d c ((nd_C_renameSymbolInConsDecl x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_ConsDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInConsDecl" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInConsDecl" (showCons x2))

d_C_renameSymbolInTypeExpr :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_TypeExpr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C_renameSymbolInTypeExpr x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_TCons x3 x4) -> Curry_AbstractHaskell.C_TCons (Curry_Prelude.d_C_apply x1 x3 cd cs) (Curry_Prelude.d_C_map (d_C_renameSymbolInTypeExpr x1) x4 cd cs)
     (Curry_AbstractHaskell.C_FuncType x5 x6) -> Curry_AbstractHaskell.C_FuncType (d_C_renameSymbolInTypeExpr x1 x5 cd cs) (d_C_renameSymbolInTypeExpr x1 x6 cd cs)
     (Curry_AbstractHaskell.C_TVar x7) -> Curry_AbstractHaskell.C_TVar x7
     (Curry_AbstractHaskell.Choice_C_TypeExpr d i l r) -> narrow d i (d_C_renameSymbolInTypeExpr x1 l cd cs) (d_C_renameSymbolInTypeExpr x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_TypeExpr d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInTypeExpr x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_TypeExpr d c e) -> guardCons d c ((d_C_renameSymbolInTypeExpr x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_TypeExpr d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeExpr" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeExpr" (showCons x2))

nd_C_renameSymbolInTypeExpr :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
nd_C_renameSymbolInTypeExpr x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_TCons x3 x4) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_TCons (let
                     in (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInTypeExpr x1)) x4 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_FuncType x5 x6) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_FuncType (let
                     in (nd_C_renameSymbolInTypeExpr x1 x5 s0 cd cs)) (let
                     in (nd_C_renameSymbolInTypeExpr x1 x6 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_TVar x7) -> Curry_AbstractHaskell.C_TVar x7
     (Curry_AbstractHaskell.Choice_C_TypeExpr d i l r) -> narrow d i (nd_C_renameSymbolInTypeExpr x1 l s cd cs) (nd_C_renameSymbolInTypeExpr x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_TypeExpr d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInTypeExpr x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_TypeExpr d c e) -> guardCons d c ((nd_C_renameSymbolInTypeExpr x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_TypeExpr d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeExpr" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeExpr" (showCons x2))

d_C_renameSymbolInExpr :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Expr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C_renameSymbolInExpr x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Symbol x3) -> Curry_AbstractHaskell.C_Symbol (Curry_Prelude.d_C_apply x1 x3 cd cs)
     (Curry_AbstractHaskell.C_Apply x4 x5) -> Curry_AbstractHaskell.C_Apply (d_C_renameSymbolInExpr x1 x4 cd cs) (d_C_renameSymbolInExpr x1 x5 cd cs)
     (Curry_AbstractHaskell.C_Lambda x6 x7) -> Curry_AbstractHaskell.C_Lambda (Curry_Prelude.d_C_map (d_C_renameSymbolInPat x1) x6 cd cs) (d_C_renameSymbolInExpr x1 x7 cd cs)
     (Curry_AbstractHaskell.C_Let x8 x9) -> Curry_AbstractHaskell.C_Let (Curry_Prelude.d_C_map (d_C_renameSymbolInLocal x1) x8 cd cs) (d_C_renameSymbolInExpr x1 x9 cd cs)
     (Curry_AbstractHaskell.C_DoExpr x10) -> Curry_AbstractHaskell.C_DoExpr (Curry_Prelude.d_C_map (d_C_renameSymbolInStat x1) x10 cd cs)
     (Curry_AbstractHaskell.C_ListComp x11 x12) -> Curry_AbstractHaskell.C_ListComp (d_C_renameSymbolInExpr x1 x11 cd cs) (Curry_Prelude.d_C_map (d_C_renameSymbolInStat x1) x12 cd cs)
     (Curry_AbstractHaskell.C_Case x13 x14) -> Curry_AbstractHaskell.C_Case (d_C_renameSymbolInExpr x1 x13 cd cs) (Curry_Prelude.d_C_map (d_C_renameSymbolInBranch x1) x14 cd cs)
     (Curry_AbstractHaskell.C_Typed x15 x16) -> Curry_AbstractHaskell.C_Typed (d_C_renameSymbolInExpr x1 x15 cd cs) x16
     (Curry_AbstractHaskell.C_IfThenElse x17 x18 x19) -> Curry_AbstractHaskell.C_IfThenElse (d_C_renameSymbolInExpr x1 x17 cd cs) (d_C_renameSymbolInExpr x1 x18 cd cs) (d_C_renameSymbolInExpr x1 x19 cd cs)
     (Curry_AbstractHaskell.C_Var x20) -> x2
     (Curry_AbstractHaskell.C_Lit x21) -> x2
     (Curry_AbstractHaskell.Choice_C_Expr d i l r) -> narrow d i (d_C_renameSymbolInExpr x1 l cd cs) (d_C_renameSymbolInExpr x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_Expr d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInExpr x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Expr d c e) -> guardCons d c ((d_C_renameSymbolInExpr x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Expr d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInExpr" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInExpr" (showCons x2))

nd_C_renameSymbolInExpr :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Expr -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
nd_C_renameSymbolInExpr x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Symbol x3) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_Symbol (let
                     in (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)))))
     (Curry_AbstractHaskell.C_Apply x4 x5) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_Apply (let
                     in (nd_C_renameSymbolInExpr x1 x4 s0 cd cs)) (let
                     in (nd_C_renameSymbolInExpr x1 x5 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_Lambda x6 x7) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_Lambda (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInPat x1)) x6 s0 cd cs)) (let
                     in (nd_C_renameSymbolInExpr x1 x7 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_Let x8 x9) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_Let (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInLocal x1)) x8 s0 cd cs)) (let
                     in (nd_C_renameSymbolInExpr x1 x9 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_DoExpr x10) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_DoExpr (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInStat x1)) x10 s0 cd cs)))))
     (Curry_AbstractHaskell.C_ListComp x11 x12) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_ListComp (let
                     in (nd_C_renameSymbolInExpr x1 x11 s0 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInStat x1)) x12 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_Case x13 x14) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_Case (let
                     in (nd_C_renameSymbolInExpr x1 x13 s0 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInBranch x1)) x14 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_Typed x15 x16) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_Typed (let
                     in (nd_C_renameSymbolInExpr x1 x15 s0 cd cs)) x16)))
     (Curry_AbstractHaskell.C_IfThenElse x17 x18 x19) -> let
          s3 = s
           in (seq s3 (let
               s0 = leftSupply s3
               s4 = rightSupply s3
               s1 = leftSupply s4
               s2 = rightSupply s4
                in (seq s0 (seq s4 (seq s1 (seq s2 (Curry_AbstractHaskell.C_IfThenElse (let
                     in (nd_C_renameSymbolInExpr x1 x17 s0 cd cs)) (let
                     in (nd_C_renameSymbolInExpr x1 x18 s1 cd cs)) (let
                     in (nd_C_renameSymbolInExpr x1 x19 s2 cd cs)))))))))
     (Curry_AbstractHaskell.C_Var x20) -> x2
     (Curry_AbstractHaskell.C_Lit x21) -> x2
     (Curry_AbstractHaskell.Choice_C_Expr d i l r) -> narrow d i (nd_C_renameSymbolInExpr x1 l s cd cs) (nd_C_renameSymbolInExpr x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_Expr d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInExpr x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Expr d c e) -> guardCons d c ((nd_C_renameSymbolInExpr x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Expr d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInExpr" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInExpr" (showCons x2))

d_C_renameSymbolInPat :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Pattern -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Pattern
d_C_renameSymbolInPat x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_PComb x3 x4) -> Curry_AbstractHaskell.C_PComb (Curry_Prelude.d_C_apply x1 x3 cd cs) (Curry_Prelude.d_C_map (d_C_renameSymbolInPat x1) x4 cd cs)
     (Curry_AbstractHaskell.C_PAs x5 x6) -> Curry_AbstractHaskell.C_PAs x5 (d_C_renameSymbolInPat x1 x6 cd cs)
     (Curry_AbstractHaskell.C_PFuncComb x7 x8) -> Curry_AbstractHaskell.C_PFuncComb (Curry_Prelude.d_C_apply x1 x7 cd cs) (Curry_Prelude.d_C_map (d_C_renameSymbolInPat x1) x8 cd cs)
     (Curry_AbstractHaskell.C_PVar x9) -> x2
     (Curry_AbstractHaskell.C_PLit x10) -> x2
     (Curry_AbstractHaskell.Choice_C_Pattern d i l r) -> narrow d i (d_C_renameSymbolInPat x1 l cd cs) (d_C_renameSymbolInPat x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_Pattern d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInPat x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Pattern d c e) -> guardCons d c ((d_C_renameSymbolInPat x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Pattern d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInPat" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInPat" (showCons x2))

nd_C_renameSymbolInPat :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Pattern -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Pattern
nd_C_renameSymbolInPat x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_PComb x3 x4) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_PComb (let
                     in (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInPat x1)) x4 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_PAs x5 x6) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_PAs x5 (let
                     in (nd_C_renameSymbolInPat x1 x6 s0 cd cs)))))
     (Curry_AbstractHaskell.C_PFuncComb x7 x8) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_PFuncComb (let
                     in (Curry_Prelude.nd_C_apply x1 x7 s0 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInPat x1)) x8 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_PVar x9) -> x2
     (Curry_AbstractHaskell.C_PLit x10) -> x2
     (Curry_AbstractHaskell.Choice_C_Pattern d i l r) -> narrow d i (nd_C_renameSymbolInPat x1 l s cd cs) (nd_C_renameSymbolInPat x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_Pattern d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInPat x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Pattern d c e) -> guardCons d c ((nd_C_renameSymbolInPat x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Pattern d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInPat" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInPat" (showCons x2))

d_C_renameSymbolInBranch :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_BranchExpr -> Cover -> ConstStore -> Curry_AbstractHaskell.C_BranchExpr
d_C_renameSymbolInBranch x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Branch x3 x4) -> Curry_AbstractHaskell.C_Branch (d_C_renameSymbolInPat x1 x3 cd cs) (d_C_renameSymbolInExpr x1 x4 cd cs)
     (Curry_AbstractHaskell.Choice_C_BranchExpr d i l r) -> narrow d i (d_C_renameSymbolInBranch x1 l cd cs) (d_C_renameSymbolInBranch x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_BranchExpr d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInBranch x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_BranchExpr d c e) -> guardCons d c ((d_C_renameSymbolInBranch x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_BranchExpr d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInBranch" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInBranch" (showCons x2))

nd_C_renameSymbolInBranch :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_BranchExpr -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_BranchExpr
nd_C_renameSymbolInBranch x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Branch x3 x4) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_Branch (let
                     in (nd_C_renameSymbolInPat x1 x3 s0 cd cs)) (let
                     in (nd_C_renameSymbolInExpr x1 x4 s1 cd cs)))))))
     (Curry_AbstractHaskell.Choice_C_BranchExpr d i l r) -> narrow d i (nd_C_renameSymbolInBranch x1 l s cd cs) (nd_C_renameSymbolInBranch x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_BranchExpr d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInBranch x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_BranchExpr d c e) -> guardCons d c ((nd_C_renameSymbolInBranch x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_BranchExpr d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInBranch" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInBranch" (showCons x2))

d_C_renameSymbolInStat :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Statement -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Statement
d_C_renameSymbolInStat x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_SExpr x3) -> Curry_AbstractHaskell.C_SExpr (d_C_renameSymbolInExpr x1 x3 cd cs)
     (Curry_AbstractHaskell.C_SPat x4 x5) -> Curry_AbstractHaskell.C_SPat (d_C_renameSymbolInPat x1 x4 cd cs) (d_C_renameSymbolInExpr x1 x5 cd cs)
     (Curry_AbstractHaskell.C_SLet x6) -> Curry_AbstractHaskell.C_SLet (Curry_Prelude.d_C_map (d_C_renameSymbolInLocal x1) x6 cd cs)
     (Curry_AbstractHaskell.Choice_C_Statement d i l r) -> narrow d i (d_C_renameSymbolInStat x1 l cd cs) (d_C_renameSymbolInStat x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_Statement d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInStat x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Statement d c e) -> guardCons d c ((d_C_renameSymbolInStat x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Statement d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInStat" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInStat" (showCons x2))

nd_C_renameSymbolInStat :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Statement -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Statement
nd_C_renameSymbolInStat x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_SExpr x3) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_SExpr (let
                     in (nd_C_renameSymbolInExpr x1 x3 s0 cd cs)))))
     (Curry_AbstractHaskell.C_SPat x4 x5) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_SPat (let
                     in (nd_C_renameSymbolInPat x1 x4 s0 cd cs)) (let
                     in (nd_C_renameSymbolInExpr x1 x5 s1 cd cs)))))))
     (Curry_AbstractHaskell.C_SLet x6) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_SLet (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInLocal x1)) x6 s0 cd cs)))))
     (Curry_AbstractHaskell.Choice_C_Statement d i l r) -> narrow d i (nd_C_renameSymbolInStat x1 l s cd cs) (nd_C_renameSymbolInStat x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_Statement d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInStat x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Statement d c e) -> guardCons d c ((nd_C_renameSymbolInStat x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Statement d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInStat" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInStat" (showCons x2))

d_C_renameSymbolInLocal :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_LocalDecl -> Cover -> ConstStore -> Curry_AbstractHaskell.C_LocalDecl
d_C_renameSymbolInLocal x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_LocalFunc x3) -> Curry_AbstractHaskell.C_LocalFunc (d_C_renameSymbolInFunc x1 x3 cd cs)
     (Curry_AbstractHaskell.C_LocalPat x4 x5 x6) -> Curry_AbstractHaskell.C_LocalPat (d_C_renameSymbolInPat x1 x4 cd cs) (d_C_renameSymbolInExpr x1 x5 cd cs) (Curry_Prelude.d_C_map (d_C_renameSymbolInLocal x1) x6 cd cs)
     (Curry_AbstractHaskell.Choice_C_LocalDecl d i l r) -> narrow d i (d_C_renameSymbolInLocal x1 l cd cs) (d_C_renameSymbolInLocal x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_LocalDecl d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInLocal x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_LocalDecl d c e) -> guardCons d c ((d_C_renameSymbolInLocal x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_LocalDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInLocal" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInLocal" (showCons x2))

nd_C_renameSymbolInLocal :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_LocalDecl -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_LocalDecl
nd_C_renameSymbolInLocal x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_LocalFunc x3) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_LocalFunc (let
                     in (nd_C_renameSymbolInFunc x1 x3 s0 cd cs)))))
     (Curry_AbstractHaskell.C_LocalPat x4 x5 x6) -> let
          s3 = s
           in (seq s3 (let
               s0 = leftSupply s3
               s4 = rightSupply s3
               s1 = leftSupply s4
               s2 = rightSupply s4
                in (seq s0 (seq s4 (seq s1 (seq s2 (Curry_AbstractHaskell.C_LocalPat (let
                     in (nd_C_renameSymbolInPat x1 x4 s0 cd cs)) (let
                     in (nd_C_renameSymbolInExpr x1 x5 s1 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInLocal x1)) x6 s2 cd cs)))))))))
     (Curry_AbstractHaskell.Choice_C_LocalDecl d i l r) -> narrow d i (nd_C_renameSymbolInLocal x1 l s cd cs) (nd_C_renameSymbolInLocal x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_LocalDecl d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInLocal x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_LocalDecl d c e) -> guardCons d c ((nd_C_renameSymbolInLocal x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_LocalDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInLocal" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInLocal" (showCons x2))

d_C_renameSymbolInTypeSig :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_TypeSig -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeSig
d_C_renameSymbolInTypeSig x1 x2 cd cs = case x2 of
     Curry_AbstractHaskell.C_Untyped -> Curry_AbstractHaskell.C_Untyped
     (Curry_AbstractHaskell.C_FType x3) -> Curry_AbstractHaskell.C_FType (d_C_renameSymbolInTypeExpr x1 x3 cd cs)
     (Curry_AbstractHaskell.C_CType x4 x5) -> Curry_AbstractHaskell.C_CType (Curry_Prelude.d_C_map (d_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1) x4 cd cs) (d_C_renameSymbolInTypeExpr x1 x5 cd cs)
     (Curry_AbstractHaskell.Choice_C_TypeSig d i l r) -> narrow d i (d_C_renameSymbolInTypeSig x1 l cd cs) (d_C_renameSymbolInTypeSig x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_TypeSig d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInTypeSig x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_TypeSig d c e) -> guardCons d c ((d_C_renameSymbolInTypeSig x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_TypeSig d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeSig" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeSig" (showCons x2))

nd_C_renameSymbolInTypeSig :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_TypeSig -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeSig
nd_C_renameSymbolInTypeSig x1 x2 s cd cs = case x2 of
     Curry_AbstractHaskell.C_Untyped -> Curry_AbstractHaskell.C_Untyped
     (Curry_AbstractHaskell.C_FType x3) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_FType (let
                     in (nd_C_renameSymbolInTypeExpr x1 x3 s0 cd cs)))))
     (Curry_AbstractHaskell.C_CType x4 x5) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_AbstractHaskell.C_CType (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1)) x4 s0 cd cs)) (let
                     in (nd_C_renameSymbolInTypeExpr x1 x5 s1 cd cs)))))))
     (Curry_AbstractHaskell.Choice_C_TypeSig d i l r) -> narrow d i (nd_C_renameSymbolInTypeSig x1 l s cd cs) (nd_C_renameSymbolInTypeSig x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_TypeSig d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInTypeSig x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_TypeSig d c e) -> guardCons d c ((nd_C_renameSymbolInTypeSig x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_TypeSig d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeSig" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeSig" (showCons x2))

d_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Context -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Context
d_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Context x3 x4) -> Curry_AbstractHaskell.C_Context (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
     (Curry_AbstractHaskell.Choice_C_Context d i l r) -> narrow d i (d_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1 l cd cs) (d_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_Context d i xs) -> narrows cs d i (\z -> d_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Context d c e) -> guardCons d c ((d_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Context d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeSig._#lambda9" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeSig._#lambda9" (showCons x2))

nd_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Context -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Context
nd_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Context x3 x4) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_Context (let
                     in (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)) x4)))
     (Curry_AbstractHaskell.Choice_C_Context d i l r) -> narrow d i (nd_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1 l s cd cs) (nd_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_Context d i xs) -> narrows cs d i (\z -> nd_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Context d c e) -> guardCons d c ((nd_OP_renameSymbolInTypeSig_dot_uscore_hash_lambda9 x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Context d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInTypeSig._#lambda9" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInTypeSig._#lambda9" (showCons x2))

d_C_renameSymbolInFunc :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_FuncDecl -> Cover -> ConstStore -> Curry_AbstractHaskell.C_FuncDecl
d_C_renameSymbolInFunc x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Func x3 x4 x5 x6 x7 x8) -> Curry_AbstractHaskell.C_Func x3 (Curry_Prelude.d_C_apply x1 x4 cd cs) x5 x6 (d_C_renameSymbolInTypeSig x1 x7 cd cs) (d_C_renameSymbolInRules x1 x8 cd cs)
     (Curry_AbstractHaskell.Choice_C_FuncDecl d i l r) -> narrow d i (d_C_renameSymbolInFunc x1 l cd cs) (d_C_renameSymbolInFunc x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_FuncDecl d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInFunc x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_FuncDecl d c e) -> guardCons d c ((d_C_renameSymbolInFunc x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_FuncDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInFunc" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInFunc" (showCons x2))

nd_C_renameSymbolInFunc :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_FuncDecl -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_FuncDecl
nd_C_renameSymbolInFunc x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Func x3 x4 x5 x6 x7 x8) -> let
          s3 = s
           in (seq s3 (let
               s0 = leftSupply s3
               s4 = rightSupply s3
               s1 = leftSupply s4
               s2 = rightSupply s4
                in (seq s0 (seq s4 (seq s1 (seq s2 (Curry_AbstractHaskell.C_Func x3 (let
                     in (Curry_Prelude.nd_C_apply x1 x4 s0 cd cs)) x5 x6 (let
                     in (nd_C_renameSymbolInTypeSig x1 x7 s1 cd cs)) (let
                     in (nd_C_renameSymbolInRules x1 x8 s2 cd cs)))))))))
     (Curry_AbstractHaskell.Choice_C_FuncDecl d i l r) -> narrow d i (nd_C_renameSymbolInFunc x1 l s cd cs) (nd_C_renameSymbolInFunc x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_FuncDecl d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInFunc x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_FuncDecl d c e) -> guardCons d c ((nd_C_renameSymbolInFunc x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_FuncDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInFunc" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInFunc" (showCons x2))

d_C_renameSymbolInRules :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Rules -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Rules
d_C_renameSymbolInRules x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Rules x3) -> Curry_AbstractHaskell.C_Rules (Curry_Prelude.d_C_map (d_C_renameSymbolInRule x1) x3 cd cs)
     (Curry_AbstractHaskell.C_External x4) -> Curry_AbstractHaskell.C_External x4
     (Curry_AbstractHaskell.Choice_C_Rules d i l r) -> narrow d i (d_C_renameSymbolInRules x1 l cd cs) (d_C_renameSymbolInRules x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_Rules d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInRules x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Rules d c e) -> guardCons d c ((d_C_renameSymbolInRules x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Rules d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInRules" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInRules" (showCons x2))

nd_C_renameSymbolInRules :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Rules -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Rules
nd_C_renameSymbolInRules x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Rules x3) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_Rules (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInRule x1)) x3 s0 cd cs)))))
     (Curry_AbstractHaskell.C_External x4) -> Curry_AbstractHaskell.C_External x4
     (Curry_AbstractHaskell.Choice_C_Rules d i l r) -> narrow d i (nd_C_renameSymbolInRules x1 l s cd cs) (nd_C_renameSymbolInRules x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_Rules d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInRules x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Rules d c e) -> guardCons d c ((nd_C_renameSymbolInRules x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Rules d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInRules" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInRules" (showCons x2))

d_C_renameSymbolInRule :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Rule -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Rule
d_C_renameSymbolInRule x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Rule x3 x4 x5) -> Curry_AbstractHaskell.C_Rule (Curry_Prelude.d_C_map (d_C_renameSymbolInPat x1) x3 cd cs) (Curry_Prelude.d_C_map (d_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1) x4 cd cs) (Curry_Prelude.d_C_map (d_C_renameSymbolInLocal x1) x5 cd cs)
     (Curry_AbstractHaskell.Choice_C_Rule d i l r) -> narrow d i (d_C_renameSymbolInRule x1 l cd cs) (d_C_renameSymbolInRule x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_Rule d i xs) -> narrows cs d i (\z -> d_C_renameSymbolInRule x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Rule d c e) -> guardCons d c ((d_C_renameSymbolInRule x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Rule d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInRule" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInRule" (showCons x2))

nd_C_renameSymbolInRule :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_Rule -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Rule
nd_C_renameSymbolInRule x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Rule x3 x4 x5) -> let
          s3 = s
           in (seq s3 (let
               s0 = leftSupply s3
               s4 = rightSupply s3
               s1 = leftSupply s4
               s2 = rightSupply s4
                in (seq s0 (seq s4 (seq s1 (seq s2 (Curry_AbstractHaskell.C_Rule (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInPat x1)) x3 s0 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1)) x4 s1 cd cs)) (let
                     in (Curry_Prelude.nd_C_map (wrapNX id (nd_C_renameSymbolInLocal x1)) x5 s2 cd cs)))))))))
     (Curry_AbstractHaskell.Choice_C_Rule d i l r) -> narrow d i (nd_C_renameSymbolInRule x1 l s cd cs) (nd_C_renameSymbolInRule x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_Rule d i xs) -> narrows cs d i (\z -> nd_C_renameSymbolInRule x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Rule d c e) -> guardCons d c ((nd_C_renameSymbolInRule x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Rule d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInRule" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInRule" (showCons x2))

d_OP_renameSymbolInRule_dot_uscore_hash_lambda10 :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Expr Curry_AbstractHaskell.C_Expr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Expr Curry_AbstractHaskell.C_Expr
d_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_Prelude.OP_Tuple2 (d_C_renameSymbolInExpr x1 x3 cd cs) (d_C_renameSymbolInExpr x1 x4 cd cs)
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1 l cd cs) (d_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInRule._#lambda10" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInRule._#lambda10" (showCons x2))

nd_OP_renameSymbolInRule_dot_uscore_hash_lambda10 :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Expr Curry_AbstractHaskell.C_Expr -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_AbstractHaskell.C_Expr Curry_AbstractHaskell.C_Expr
nd_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1 x2 s cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_Prelude.OP_Tuple2 (let
                     in (nd_C_renameSymbolInExpr x1 x3 s0 cd cs)) (let
                     in (nd_C_renameSymbolInExpr x1 x4 s1 cd cs)))))))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1 l s cd cs) (nd_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_OP_renameSymbolInRule_dot_uscore_hash_lambda10 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameSymbolInRule._#lambda10" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameSymbolInRule._#lambda10" (showCons x2))

d_C_renameOpDecl :: (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_OpDecl -> Cover -> ConstStore -> Curry_AbstractHaskell.C_OpDecl
d_C_renameOpDecl x1 x2 cd cs = case x2 of
     (Curry_AbstractHaskell.C_Op x3 x4 x5) -> Curry_AbstractHaskell.C_Op (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 x5
     (Curry_AbstractHaskell.Choice_C_OpDecl d i l r) -> narrow d i (d_C_renameOpDecl x1 l cd cs) (d_C_renameOpDecl x1 r cd cs)
     (Curry_AbstractHaskell.Choices_C_OpDecl d i xs) -> narrows cs d i (\z -> d_C_renameOpDecl x1 z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_OpDecl d c e) -> guardCons d c ((d_C_renameOpDecl x1 e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_OpDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameOpDecl" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameOpDecl" (showCons x2))

nd_C_renameOpDecl :: Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_AbstractHaskell.C_OpDecl -> IDSupply -> Cover -> ConstStore -> Curry_AbstractHaskell.C_OpDecl
nd_C_renameOpDecl x1 x2 s cd cs = case x2 of
     (Curry_AbstractHaskell.C_Op x3 x4 x5) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_AbstractHaskell.C_Op (let
                     in (Curry_Prelude.nd_C_apply x1 x3 s0 cd cs)) x4 x5)))
     (Curry_AbstractHaskell.Choice_C_OpDecl d i l r) -> narrow d i (nd_C_renameOpDecl x1 l s cd cs) (nd_C_renameOpDecl x1 r s cd cs)
     (Curry_AbstractHaskell.Choices_C_OpDecl d i xs) -> narrows cs d i (\z -> nd_C_renameOpDecl x1 z s cd cs) xs
     (Curry_AbstractHaskell.Guard_C_OpDecl d c e) -> guardCons d c ((nd_C_renameOpDecl x1 e s cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_OpDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.renameOpDecl" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.renameOpDecl" (showCons x2))

d_C_funcDecls :: Curry_AbstractHaskell.C_Prog -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_FuncDecl
d_C_funcDecls x1 cd cs = case x1 of
     (Curry_AbstractHaskell.C_Prog x2 x3 x4 x5 x6) -> x5
     (Curry_AbstractHaskell.Choice_C_Prog d i l r) -> narrow d i (d_C_funcDecls l cd cs) (d_C_funcDecls r cd cs)
     (Curry_AbstractHaskell.Choices_C_Prog d i xs) -> narrows cs d i (\z -> d_C_funcDecls z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_Prog d c e) -> guardCons d c ((d_C_funcDecls e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_Prog d info) -> failCons d (traceFail "AbstractHaskellGoodies.funcDecls" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.funcDecls" (showCons x1))

d_C_funcName :: Curry_AbstractHaskell.C_FuncDecl -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_funcName x1 cd cs = case x1 of
     (Curry_AbstractHaskell.C_Func x2 x3 x4 x5 x6 x7) -> x3
     (Curry_AbstractHaskell.Choice_C_FuncDecl d i l r) -> narrow d i (d_C_funcName l cd cs) (d_C_funcName r cd cs)
     (Curry_AbstractHaskell.Choices_C_FuncDecl d i xs) -> narrows cs d i (\z -> d_C_funcName z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_FuncDecl d c e) -> guardCons d c ((d_C_funcName e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_FuncDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.funcName" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.funcName" (showCons x1))

d_C_typeOf :: Curry_AbstractHaskell.C_FuncDecl -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeSig
d_C_typeOf x1 cd cs = case x1 of
     (Curry_AbstractHaskell.C_Func x2 x3 x4 x5 x6 x7) -> x6
     (Curry_AbstractHaskell.Choice_C_FuncDecl d i l r) -> narrow d i (d_C_typeOf l cd cs) (d_C_typeOf r cd cs)
     (Curry_AbstractHaskell.Choices_C_FuncDecl d i xs) -> narrows cs d i (\z -> d_C_typeOf z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_FuncDecl d c e) -> guardCons d c ((d_C_typeOf e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_FuncDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.typeOf" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.typeOf" (showCons x1))

d_C_commentOf :: Curry_AbstractHaskell.C_FuncDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_commentOf x1 cd cs = case x1 of
     (Curry_AbstractHaskell.C_Func x2 x3 x4 x5 x6 x7) -> x2
     (Curry_AbstractHaskell.Choice_C_FuncDecl d i l r) -> narrow d i (d_C_commentOf l cd cs) (d_C_commentOf r cd cs)
     (Curry_AbstractHaskell.Choices_C_FuncDecl d i xs) -> narrows cs d i (\z -> d_C_commentOf z cd cs) xs
     (Curry_AbstractHaskell.Guard_C_FuncDecl d c e) -> guardCons d c ((d_C_commentOf e cd) $! (addCs c cs))
     (Curry_AbstractHaskell.Fail_C_FuncDecl d info) -> failCons d (traceFail "AbstractHaskellGoodies.commentOf" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies.commentOf" (showCons x1))

d_C__case_0 :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_LocalDecl -> Curry_AbstractHaskell.C_Expr -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C__case_0 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> x2
     Curry_Prelude.C_False -> Curry_AbstractHaskell.C_Let x1 x2
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_0 x1 x2 l cd cs) (d_C__case_0 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_0 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_0 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_0" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_0" (showCons x3))

d_C__case_3 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_TypeExpr -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C__case_3 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_baseType (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List)) cd cs) cd cs
     Curry_Prelude.C_False -> d_C__case_2 x2 x1 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 1#) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_3 x2 x1 l cd cs) (d_C__case_3 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_3 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_3 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_3" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_3" (showCons x3))

d_C__case_2 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_TypeExpr -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C__case_2 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_head x1 cd cs
     Curry_Prelude.C_False -> d_C__case_1 x1 x2 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_2 x2 x1 l cd cs) (d_C__case_2 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_2 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_2 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_2" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_2" (showCons x3))

d_C__case_1 :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_TypeExpr -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_TypeExpr
d_C__case_1 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_AbstractHaskell.C_TCons (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_take (Curry_Prelude.d_OP_minus x2 (Curry_Prelude.C_Int 1#) cd cs) (Curry_Prelude.d_C_repeat (Curry_Prelude.C_Char ','#) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List) cd cs)) cd cs) x1
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_1 x1 x2 l cd cs) (d_C__case_1 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_1 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_1 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_1" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_1" (showCons x3))

d_C__case_6 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Pattern -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Pattern
d_C__case_6 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_AbstractHaskell.C_PComb (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List)) cd cs) Curry_Prelude.OP_List
     Curry_Prelude.C_False -> d_C__case_5 x2 x1 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 1#) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_6 x2 x1 l cd cs) (d_C__case_6 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_6 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_6 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_6" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_6" (showCons x3))

d_C__case_5 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Pattern -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Pattern
d_C__case_5 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_head x1 cd cs
     Curry_Prelude.C_False -> d_C__case_4 x1 x2 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_5 x2 x1 l cd cs) (d_C__case_5 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_5 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_5 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_5" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_5" (showCons x3))

d_C__case_4 :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_Pattern -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Pattern
d_C__case_4 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_AbstractHaskell.C_PComb (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_take (Curry_Prelude.d_OP_minus x2 (Curry_Prelude.C_Int 1#) cd cs) (Curry_Prelude.d_C_repeat (Curry_Prelude.C_Char ','#) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List) cd cs)) cd cs) x1
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_4 x1 x2 l cd cs) (d_C__case_4 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_4 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_4 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_4" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_4" (showCons x3))

d_C__case_9 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Expr -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C__case_9 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_constF (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List)) cd cs) cd cs
     Curry_Prelude.C_False -> d_C__case_8 x2 x1 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 1#) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_9 x2 x1 l cd cs) (d_C__case_9 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_9 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_9 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_9" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_9" (showCons x3))

d_C__case_8 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Expr -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C__case_8 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_head x1 cd cs
     Curry_Prelude.C_False -> d_C__case_7 x1 x2 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_8 x2 x1 l cd cs) (d_C__case_8 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_8 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_8 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_8" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_8" (showCons x3))

d_C__case_7 :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_Expr -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Expr
d_C__case_7 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> d_C_applyF (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_take (Curry_Prelude.d_OP_minus x2 (Curry_Prelude.C_Int 1#) cd cs) (Curry_Prelude.d_C_repeat (Curry_Prelude.C_Char ','#) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List) cd cs)) cd cs) x1 cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_7 x1 x2 l cd cs) (d_C__case_7 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_7 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_7 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_7" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_7" (showCons x3))

d_C__case_12 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Pattern -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Pattern
d_C__case_12 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_AbstractHaskell.C_PComb (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List)) cd cs) Curry_Prelude.OP_List
     Curry_Prelude.C_False -> d_C__case_11 x2 x1 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Int 1#) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_12 x2 x1 l cd cs) (d_C__case_12 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_12 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_12 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_12" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_12" (showCons x3))

d_C__case_11 :: Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_AbstractHaskell.C_Pattern -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Pattern
d_C__case_11 x2 x1 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_Prelude.d_C_head x1 cd cs
     Curry_Prelude.C_False -> d_C__case_10 x1 x2 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_11 x2 x1 l cd cs) (d_C__case_11 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_11 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_11 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_11" [(show x2),(show x1),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_11" (showCons x3))

d_C__case_10 :: Curry_Prelude.OP_List Curry_AbstractHaskell.C_Pattern -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_AbstractHaskell.C_Pattern
d_C__case_10 x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.C_True -> Curry_AbstractHaskell.C_PComb (d_C_pre (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_take (Curry_Prelude.d_OP_minus x2 (Curry_Prelude.C_Int 1#) cd cs) (Curry_Prelude.d_C_repeat (Curry_Prelude.C_Char ','#) cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List) cd cs)) cd cs) x1
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_10 x1 x2 l cd cs) (d_C__case_10 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_10 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_10 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractHaskellGoodies._case_10" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "AbstractHaskellGoodies._case_10" (showCons x3))